# Visual Development with React

Visual development was broken in the world of web development, mostly because pre-defined visual components could not be re-used anymore.
The industry de-facto accepts the fact that complex web apps can **not** be developed visually.

jBart suggests a revolutionary approach for visual development of complex apps that actually works.

![jBart](http://storage.googleapis.com/letmesee1/p80kd9kkn6/files/a350b50375cf4e1a8b98d1d4137879e4_data_binding.gif)

## Install
- mkdir myProj
- cd myProj
- npm init (answer with Enter)
- npm i --save jb-react
- node ./node_modules/jb-react/bin/studio/studio-server.js
- goto http://localhost:8083/studio-bin

- create a new project
- enjoy.. use the tutorial at http://jb-letmesee.appspot.com/LetMeSee/p80kd9kkn6.html?roomid=hd8mns

## Visual Development Concepts
- drag any visual element from the web
- pick & edit (pick like in Chrome debugger, edit like in powerpoint)
- integrated studios for different developments scenarios: ui development, forms, data binding, parsing, etc.
- coding is not forbeeden - clean textual representation of your code in declarative javascript
- work by example data

## Visual Development Benefits
- faster delivery
- enhance quality
- reduce development/maintenance costs
- non technical people can build complex business apps
- develop larger projects
- enhance team work effectiveness

## jBart is written by itself
- core is written as a react compatible engine
- studio is written by itself (like the C compiler written in C)

## Learn jbart
If you want to learn more about jBart visual development concepts, please start with [tutorial](http://jb-letmesee.appspot.com/LetMeSee/p80kd9kkn6.html?roomid=hd8mns)
